<?php

/**

 * Ajoute des utilisateurs dans l'annuaire
 * @Version
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 */

/**
 *
 * @Repertoire: annu
 * file: add_user.php
 */
require "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("lang.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
echo header_authorize($config);
require_once "ldap.inc.php";
require_once "functions.inc.php";
require_once ("samba-tool.inc.php");

require_once ("ent.inc.php");
// HTMLPurifier
// require_once ("traitement_data.inc.php");

require "ihm.inc.php";
require_once ("lang.inc.php");
bindtextdomain('sambaedu-core', "/var/www/sambaedu/locale");
textdomain('sambaedu-core');
echo "<h1>" . gettext("Annuaire") . "</h1>\n";

@session_start();
$_SESSION["pageaide"] = "Annuaire";
aff_trailer("7");

if (! isset($_SESSION['comptes_crees'])) {
    $_SESSION['comptes_crees'] = array(
        array()
    ); // un sous-tableau par compte ; le deuxième tavbleau est, dans l'ordre nom, prenom, classe (?? en fait, non) (ou 'prof'), cn, password
    array_splice($_SESSION['comptes_crees'], 0, 1);
}
$etabs = list_etabs($config);
$etabs[0] = "Domaine entier";
if (count($etabs) > 1) {
    if (! isset($_POST['uai']) && ! isset($config['etab_ou'])) {
        $choix = "<SELECT NAME=\"uai\" SIZE=\"1\" onchange=submit()>";
        $etab = 0;
        foreach ($etabs as $e) {
            $choix .= "<option value=\"" . $e . "\"";
            if ($etab == $e) {
                $choix .= " selected";
            }
            $choix .= ">" . etab_to_name($config, $e) . "\n";
            $choix .= "</option>";
        }
        $choix .= "</SELECT>\n";
    } else {
        $etab = $_POST['uai'] ?? $config['etab_ou'];
        $choix = etab_to_name($config, $etab);
    }
} else {
    $choix = $config['etab_name'] ?? "";
    $etab = 0;
}
$users = apcu_fetch('ent');
$nom = $_POST['nom'] ?? $_GET['nom'] ?? $users[0]['ent']['lastName'] ?? "";
$prenom = $_POST['prenom'] ?? $_GET['prenom'] ?? $users[0]['ent']['firstName'] ?? "";
$naissance = $_POST['naissance'] ?? $_GET['naissance'] ?? $users[0]['ent']['birthDate'] ?? "";
$password = $_POST['userpw'] ?? $_GET['userpw'] ?? $users[0]['ent']['code'] ?? "";
$sexe = $_POST['sexe'] ?? $_GET['sexe'] ?? $users[0]['ent']['sex'] ?? "";
$categorie = $_POST['categorie'] ?? $_GET['categorie'] ?? $users[0]['ent']['type'] ?? "";
$originallogin = $_POST['login'] ?? $_GET['login'] ?? $users[0]['ent']['login'] ?? "";
$id = $_POST['id'] ?? $_GET['id'] ?? $users[0]['ent']['id Pronote'] ?? "";
$classes = $_POST['classes'] ?? $users[0]['ent']['allClasses'] ?? [];
$add_user = isset($_POST['add_user']) ? $_POST['add_user'] : "";
$config['pwdPolicy'] = $config['pwdPolicy'] ?? 0;
$rules = get_password_rule($config);
$length = $rules['min-pwd-length'];
if ($rules['complexity'] == "on")
    $complexity = true;
else
    $complexity = false;

if (have_right($config, "Annu_is_admin")) {
    // Ajout d'un utilisateur
    if ((! isset($_POST['add_user'])) || (! $nom || ! $prenom) || // absence de nom ou de prenom
    ($password && ! verifPwd($password, $length, $complexity)[0]) || // mot de passe invalide
    ($password && $password != ensure_ascii($password)) || // mot de passe invalide
    ($naissance && ! verifDateNaissance($naissance)) || // date de naissance invalide
    (($naissance && verifDateNaissance($naissance)) && ($password && ! verifPwd($password, $length, $complexity)[0]))) // date de naissance mais password invalide
                                                                                                                        // || ($userpwd && !verifPwd($userpwd) ) // password invalide
    {
        ?>
<form name="auth" action="add_user.php" method="post"
    onSubmit="encrypt(document.auth)">
    <table border="0">
        <tbody>
            <tr>
                <td>Etablissement</td>
                <td colspan="2" valign="top"><?php echo $choix ?></td>

            </tr>

            <tr>
                <td><?php echo gettext("Nom :"); ?></td>
                <td colspan="2" valign="top"><input type="text" name="nom"
                    value="<?php echo $nom ?>" size="20"></td>

            </tr>
            <tr>
                <td><?php echo gettext("Prénom :"); ?></td>
                <td colspan="2" valign="top"><input type="text" name="prenom"
                    value="<?php echo $prenom ?>" size="20"></td>

            </tr>
            <tr>
                <td><?php echo gettext("Suggestion de login :"); ?></td>
                <td colspan="2" valign="top"><input type="text" name="login"
                    value="<?php echo $originallogin ?>" size="20"></td>

            </tr>
            <tr>
                <td>Id Pronote/CAS</td>
                <td><input type="text" name="id" value="<?php echo $id ?>" size="20"></td>
                <td><font color="#FF9900">
                  &nbsp;<?php echo gettext("(XXXXXXXXXXXXXXXXXX) ce champ est optionnel. Il ne sert qu'à faciliter la mise en correspondance avec un CAS"); ?>
                </font></td>
            </tr>
            <tr>
                <td><?php echo gettext("Date de naissance :"); ?></td>
                <td><input type="text" name="naissance"
                    value="<?php echo $naissance ?>" size="8"></td>
                <td><font color="#FF9900">
                  &nbsp;<?php echo gettext("(YYYYMMDD) ce champ est optionnel. Il ne sert qu'à faciliter la mise en correspondance avec une base ENT"); ?>
                </font></td>
            </tr>
            <tr>
                <td><?php echo gettext("Mot de passe :"); ?></td>
                <td><input type="password" value="" name="userpw" size='13'
                    maxlength='13'></td>
                <td><font color="#FF9900">
                  &nbsp;<?php echo gettext("ce champ est optionnel"); ?>
                </font></td>
            </tr>
            <tr>
                <td colspan="3" valign="top">
        <?php
        echo '<blockquote><font color="#FF9900">';
        echo gettext('Si le champ mot de passe est laiss&#233; vide, un mot de passe sera cr&#233;&#233; selon la politique de mot de passe par d&#233;faut qui est d&#233;finie &#224; : ');
        $config['pwdPolicy'] = $config['pwdPolicy'] ?? 0;
        switch ($config['pwdPolicy']) {
            case 0: // date de naissance
            case 1:
                echo gettext("date de naissance (YYYYMMDD)");
                echo gettext("<br />Si ni la date de naissance ni le mot de passe ne sont renseign&#233;es, un mot de passe al&#233;atoire sera g&#233;n&#233;r&#233;");
                break;
            case 2: // aleatoire
                echo gettext("al&#233;atoire ($length car.)");
                break;
            case 3: // code
                echo gettext("code d'activation ") . $config['activation_code'];
                break;
        }
        echo '</font></blockquote>';

        ?>
              </td>


            <tr>
                <td><?php echo gettext("Cat&#233;gorie"); ?></td>
                <td colspan="2" valign="top"><select name="categorie">
                  <?php
        echo "<option value=\"Eleves\"";
        if ($categorie == "Eleves")
            echo "SELECTED";
        echo ">" . gettext("El&#232;ves") . "</option>\n";
        echo "<option value=\"Profs\"";
        if ($categorie == "Profs")
            echo "SELECTED";
        echo ">" . gettext("Profs") . "</option>\n";
        echo "<option value=\"Administratifs\"";
        if ($categorie == "Administratifs")
            echo "SELECTED";
        echo ">" . gettext("Administratifs") . "</option>\n";
        ?>
                </select></td>
            </tr>
            <tr>
                <td>Classe(s) Obligatoire pour les Elèves et les Profs</td>
                <td colspan="2" valign="top"><select name="classes[]"
                    <?php

        if ($categorie == "Profs")
            echo " multiple"?>>
                  <?php
        $liste = list_classes_etab_fast($config);
        foreach ($liste as $classe) {
            echo "<option value=\"" . $classe . "\">" . $classe . "</option>";
        }
        ?>
                </select></td>
            </tr>
<!--
            <tr>
                <td><label for='checkbox_create_home'>
                <?php
                //echo gettext("Cr&#233;er le dossier personnel imm&#233;diatement");
                ?></label></td>
                <td colspan="2" valign="top"><input type='checkbox' id='checkbox_create_home' name='create_home' value='y' /></td>
            </tr>
-->
            <tr>
                <td></td>
                <td></td>
                <td><input type="hidden" name="add_user" value="true"> <input
                    type="submit"
                    value="<?php echo gettext("Lancer la requ&#234;te"); ?>"></td>
            </tr>
        </tbody>
    </table>
</form>
<?php
        if ($add_user) {
            if ((! $nom) || (! $prenom)) {
                echo "<div class=error_msg>" . gettext("Vous devez obligatoirement renseigner les champs : nom, pr&#233;nom !") . "</div><br>\n";
            } elseif (! $naissance && ! $password && $config['pwdPolicy'] < 2) {
                echo "<div class='error_msg'>";
                echo gettext("Vous devez obligatoirement renseigner un des deux champs mot de passe ou date de naissance.");
                echo "</div><BR>\n";
            } else {
                if ((($password) && ! verifPwd($password, $length, $complexity)[0]) || (($password) && ($password != ensure_ascii($password)))) {
                    echo "<div class='error_msg'>";
                    echo verifPwd($password, $length)[1] . "</div><BR>\n";
                }
                if (($naissance) && ! verifDateNaissance($naissance)) {
                    echo "<div class='error_msg'>";
                    echo gettext("Le champ date de naissance doit &#234;tre obligatoirement au format Ann&#233;eMoisJour (YYYYMMDD).");
                    echo "</div><BR>\n";
                }
            }
        }
    } else {
        // mode ent
        $allClasses = [];
        foreach ($classes as $classe) {
            $allClasses[] = [
                'name' => $classe,
                'etab' => $etab
            ];
        }
        $ent[0] = [
            'structure' => $etab,
            'login' => $originallogin,
            'firstName' => $prenom,
            'lastName' => $nom,
            'birthDate' => $naissance,
            'code' => $password,
            'type' => map_profil($categorie, "manuel"),
            'sex' => $sexe,
            'Id Pronote' => $id,
            'allClasses' => $allClasses
        ];
        $session = "add_user_" . session_id();
        $lock = apcu_fetch('ent_lock');
        if (isset($lock['lock']) && $lock['lock'] != $session) {
            echo "Une tâche d'importation de comptes est déjà en cours. Veuillez réessayer plus tard<br>";
        } else {
            apcu_add('ent_lock', [
                'lock' => $session
            ], $config['ent_timeout']);
            apcu_delete('ent');
            apcu_delete('total');
            apcu_delete('match');
            apcu_store('ent', $ent, $config['ent_timeout']);
            match_ad_from_ent($config, 10, true, false, true);
            if (! $html = apcu_fetch('ent_html')) {
                $html = "";
            }
            $match = apcu_fetch('match');
            $users = [];
            $ret = update_user_ent($config, $match, $users, $html, false, true);
            echo $html;
            if ($ret || $ret == 0) {
                apcu_delete('ent');
                echo gettext("L'utilisateur ") . " <strong>$prenom $nom</strong> " . gettext(" a &#233;t&#233; cr&#233;&#233; avec succ&#232;s.") . "<BR>";
                if (count($users) > 0) {
                    echo gettext("Son identifiant est ") . "<STRONG><a href='people.php?cn=" . $users[0]['ad']['cn'] . "' title=\"Modifier le compte.\">" . $users[0]['ad']["cn"] . "</a></STRONG><BR>\n";
                    echo gettext("Son mot de passe initial est ") . "<STRONG>" . $users[0]['ent']["code"] . "</STRONG><BR>\n";
                    $nouveau = array(
                        'nom' => "$nom",
                        'pre' => "$prenom",
                        'cn' => $users[0]['ad']["cn"],
                        'pwd' => $users[0]['ent']["code"]
                    );
                    $_SESSION['comptes_crees'][] = $nouveau;
                    echo "<LI><A HREF=\"add_user_group.php?cn=" . $users[0]['ad']["cn"] . "\">" . gettext("Ajouter &#224; des groupes...") . "</A>\n";
                }

                if ((isset($_POST['create_home'])) && ($_POST['create_home'] == 'y')) {
                    echo "<p><b>Cr&#233;ation du dossier personnel de " . $users[0]['ad']["cn"] . "</b><br />";
                    exec("sudo /usr/share/sambaedu/shares/shares.avail/mkhome.sh " . $users[0]['ad']["cn"], $ReturnValue2);
                    echo "<pre style='color:red'>";
                    foreach ($ReturnValue2 as $key => $value) {
                        echo "$value";
                    }
                    echo "</pre>\n";
                }
            } else {
                echo "<div class='error_msg'>" . gettext("Erreur lors de la cr&#233;ation du nouvel utilisateur") . " $prenom $nom
                                </font>," . gettext(" veuillez contacter") . "
                <a href='mailto:admin@" . $config['domain'] . "?subject=PB creation nouvel utilisateur Sambaedu'>" . gettext("l'administrateur du syst&#232;me") . "</a></div><br />\n";
                echo "<p><br /></p>\n";
            }
            apcu_delete('ent_lock');
            apcu_delete('ent_count');
            apcu_delete('match');
            apcu_delete('ent_html');
            apcu_delete('group');
        }
    }

    include ("listing.inc.php");
} else {
    echo "<div class=error_msg>" . gettext("Cette application, n&#233;cessite les droits d'administrateur du serveur SambaEdu !") . "</div>";
}

include ("pdp.inc.php");
?>