<?php

/*
 * Modifie l'entree d'un utilisateur
 * @Version $Id$
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: mod_user_entry.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("lang.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
echo header_authorize($config);
require "ihm.inc.php";

require_once "partages.inc.php";
require_once "ent.inc.php";
// HTMLPurifier
require_once ("traitement_data.inc.php");

$login = $config['login'];
// if ($login != "") {

require_once ("lang.inc.php");
bindtextdomain('sambaedu-annu', "/var/www/sambaedu/locale");
textdomain('sambaedu-annu');

// echo "Modification parametres utilisateur";

// Aide
@session_start();
$_SESSION["pageaide"] = "Annuaire#Modifier_mon_compte";

echo "<h1>" . gettext("Annuaire") . "</h1>\n";

aff_trailer("4");

$isadmin = have_right($config, "Annu_is_admin");

$cn = isset($_GET['cn']) ? $_GET['cn'] : (isset($_POST['cn']) ? $_POST['cn'] : NULL);

if (! isset($cn)) {
    echo "<p style='color:red'>Erreur&nbsp;: Aucun utilisateur n'a &#233;t&#233; choisi.</p>\n", include ("pdp.inc.php");
    die();
}

// debug_var();
$corriger_givenname_si_diff = "Y";
$user_entry = isset($_POST['user_entry']) ? $_POST['user_entry'] : '';
$nom = isset($_POST['nom']) ? $_POST['nom'] : '';
$prenom = isset($_POST['prenom']) ? $_POST['prenom'] : '';
$description = isset($_POST['description']) ? $_POST['description'] : '';
$userpwd = isset($_POST['userpwd']) ? $_POST['userpwd'] : '';
$mail = isset($_POST['mail']) ? $_POST['mail'] : '';
$naissance = isset($_POST['naissance']) ? $_POST['naissance'] : '';
$newids = $_POST['ids'] ?? [];

if (have_right($config, "se3_is_admin") or ((is_my_eleve($config, $login, $cn)) and (have_right($config, "sovajon_is_admin")))) {
    // Recuperation des entrees de l'utilisateur a modifier
    $user = search_user($config, $cn);
    $ids[0] = $user['Id GPEI'] ?? "";
    $ids[1] = $user['Id Siecle'] ?? "";
    $ids[2] = $user['Id ASM'] ?? "";
    $ids[3] = $user['Id Pronote'] ?? "";
    $id = implode(",", $ids);
    if (! verifEntree($nom) || ! verifEntree($prenom) || ! verifDescription($description) || ($userpwd && ! verifPwd($userpwd)[0]) || (($naissance != '') && (! verifDateNaissance($naissance)))) {
        ?>
<form name="auth" action="mod_user_entry.php" method="post"
    onSubmit="encrypt(document.auth)">
    <table align="center" border="0" width="90%">
        <tbody>
            <tr>
                <td width="27%">Login :&nbsp;</td>
                <td width="73%" colspan="2"><tt>
                        <strong><?php echo $user["cn"]?></strong>
                    </tt></td>
            </tr>
            <td width="27%">Id unique AD / NextCloud :&nbsp;</td>
            <td width="73%" colspan="2"><tt>
                    <strong><?php echo strtoupper(to_guid($user["objectguid"]))?></strong>
                </tt></td>
            </tr>

            <tr>
                <td width="27%"><?php echo gettext("Prénom"); ?> :&nbsp;</td>
                <td width="73%" colspan="2"><input type="text" name="prenom"
                    value="<?php echo $user["prenom"] ?? ""?>" size="20"></td>
            </tr>
            <tr>
                <td><?php echo gettext("Nom"); ?>&nbsp;:&nbsp;</td>
                <td colspan="2"><input type="text" name="nom"
                    value="<?php echo $user["nom"] ?? ""?>" size="20"></td>
            </tr>

            <?php
        if ($isadmin) {
            if (isset($user['date']) && preg_match("/^[0-9]{8}$/", $user['date'])) {
                $naissance = $user['date'];
            } else {
                $naissance = "";
            }

            $user['sexe'] = $user['sexe'] ?? "M";
            $user['email'] = $user['email'] ?? "";
            ?>

            <tr>
                <td><?php echo "Login"; ?>&nbsp;:&nbsp;</td>
                <td colspan="2"><input type="text" name="login"
                    value="<?php echo $user['cn']?>" size="19"></td>
            </tr>

            <tr>
                <td>Date de naissance (Facultatif)</td>
                <td colspan="2"><input type="text" name="naissance"
                    value="<?php echo $naissance?>" size="20"></td>
            </tr>

            <tr>
                <td valign='top'><?php echo gettext("Identifiants uniques"); ?>&nbsp;:&nbsp;</td>
                <td colspan='3'><font color="orange"> <u>Attention</u> : Les numéros
                        correspondent à l'attribut 'employeeNumber' dans l'annuaire LDAP.<br />C'est
                        ce numéro qui est utilis&#233; lors d'un import des comptes pour
                        d&#233;terminer si le compte existe d&#233;j&#225; ou non.<br />Ne
                        le changez pas sans bonne raison.
                </font></td>
            </tr>
            <tr>
                <td>Id GPEI</td>
                <td>Id Siecle</td>
                <td>Id ASM</td>
                <td>Id Pronote/CAS</td>
            </tr>
            <tr>
                <td><input type="text" name="ids[0]" value="<?php echo $ids[0]?>"
                    size="20"></td>
                <td><input type="text" name="ids[1]" value="<?php echo $ids[1]?>"
                    size="20"></td>
                <td><input type="text" name="ids[2]" value="<?php echo $ids[2]?>"
                    size="20"></td>
                <td><input type="text" name="ids[3]" value="<?php echo $ids[3]?>"
                    size="20"></td>
            </tr>
            <tr>
                <td><?php echo gettext("Adresse m&#232;l"); ?>&nbsp;:&nbsp;</td>
                <td colspan="2"><input type="text" name="mail"
                    value="<?php echo $user["email"]?>" size="20"></td>
            </tr>

                <?php } ?>
            <tr>
                <td><?php echo gettext("Mot de passe"); ?>:&nbsp;</td>
                <td><input type="password" value="" name="userpwd" size='20'
                    maxlength='20'></td>
                <td colspan='2'><font color="orange"> <u><?php echo gettext("Attention"); ?></u> : <?php echo gettext("Si vous laissez ce champ vide,&nbsp;c'est l'ancien mot de passe qui sera conserv&#233;."); ?>
                    </font></td>
            </tr>
            <tr>
                <td></td>
                <td align="left"><input type="hidden" name="cn"
                    value="<?php echo $cn ?>"> <input type="hidden" name="user_entry"
                    value="true"> <input type="submit"
                    value="<?php echo gettext("Lancer la requ&#234;te"); ?>"></td>
            </tr>
        </tbody>
    </table>
</form>
<?php
        if ((isset($user_entry)) && ($user_entry)) {
            // verification des saisies
            // nom prenom
            if (! verifEntree($nom) || ! verifEntree($prenom)) {
                echo "<div class=\"error_msg\">" . gettext("Les champs nom et prenom, doivent comporter au minimum 3 caract&#232;res alphab&#233;tiques.") . "</div><br />\n";
            }
            // profil
            if ($description && ! verifDescription($description)) {
                echo "<div class=\"error_msg\">" . gettext("Veuillez reformuler le champ description.") . "</div><br />\n";
            }
            // Date de naissance
            if ($naissance != '' && ! verifDateNaissance($naissance)) {
                echo "<div class=\"error_msg\">" . gettext("La date de naissance que vous avez saisie, n'est pas conforme.") . "</div><br />\n";
            }

            // mot de passe
            if ($userpwd && ! verifPwd($userpwd)[0]) {
                echo "<div class='error_msg'>";
                echo verifPwd($userpwd)[1] . "</div><br />\n";
            }

            // fin verification des saisies
        }

        echo "<p><a href='people.php?cn=" . $cn . "'>Retour sans modification vers la fiche de $cn</a></p>\n";
    } else {

        if (! empty($_POST['login']) && $_POST['login'] != $user['cn']) {
            $mod = [
                'ad' => $user,
                'ent' => [
                    'login' => $_POST['login']
                ]
            ];
            $html = "Modification du login : <br>";
            modify_ad_login($config, $mod, $html);
            $user = search_user($config, $_POST['login']);
            $cn = $user['cn'];
            echo $html;
        }

        // Positionnement des entrees a modifier
        // $entry["sn"] = stripslashes ( utf8_encode($nom) );
        // $entry["cn"] = stripslashes ( utf8_encode($prenom)." ".utf8_encode($nom) );
        $entry["sn"] = stripslashes(ucfirst(strtolower(strtr(preg_replace("/Æ/", "AE", preg_replace("/æ/", "ae", preg_replace("/¼/", "OE", preg_replace("/½/", "oe", "$nom")))), "'ÂÄÀÁÃÄÅÇÊËÈÉÎÏÌÍÑÔÖÒÓÕ¦ÛÜÙÚÝ¾´áàâäãåçéèêëîïìíñôöðòóõ¨ûüùúýÿ¸", "_AAAAAAACEEEEIIIINOOOOOSUUUUYYZaaaaaaceeeeiiiinoooooosuuuuyyz"))));
        $entry["displayname"] = stripslashes(ucfirst(strtolower(strtr(preg_replace("/Æ/", "AE", preg_replace("/æ/", "ae", preg_replace("/¼/", "OE", preg_replace("/½/", "oe", "$prenom")))), "'ÂÄÀÁÃÄÅÇÊËÈÉÎÏÌÍÑÔÖÒÓÕ¦ÛÜÙÚÝ¾´áàâäãåçéèêëîïìíñôöðòóõ¨ûüùúýÿ¸", "_AAAAAAACEEEEIIIINOOOOOSUUUUYYZaaaaaaceeeeiiiinoooooosuuuuyyz"))) . " " . ucfirst(strtolower(strtr(preg_replace("/Æ/", "AE", preg_replace("/æ/", "ae", preg_replace("/¼/", "OE", preg_replace("/½/", "oe", "$nom")))), "'ÂÄÀÁÃÄÅÇÊËÈÉÎÏÌÍÑÔÖÒÓÕ¦ÛÜÙÚÝ¾´áàâäãåçéèêëîïìíñôöðòóõ¨ûüùúýÿ¸", "_AAAAAAACEEEEIIIINOOOOOSUUUUYYZaaaaaaceeeeiiiinoooooosuuuuyyz"))));

        // ======================================
        if ($corriger_givenname_si_diff == "Y") {
            // Le givenName est destiné à prendre pour valeur le Prenom de l'utilisateur
            $entry["givenname"] = ucfirst(strtolower(strtr(preg_replace("/Æ/", "AE", preg_replace("/æ/", "ae", preg_replace("/¼/", "OE", preg_replace("/½/", "oe", "$prenom")))), "'ÂÄÀÁÃÄÅÇÊËÈÉÎÏÌÍÑÔÖÒÓÕ¦ÛÜÙÚÝ¾´áàâäãåçéèêëîïìíñôöðòóõ¨ûüùúýÿ¸", "_AAAAAAACEEEEIIIINOOOOOSUUUUYYZaaaaaaceeeeiiiinoooooosuuuuyyz")));
        }

        if ($isadmin) {
            if ($mail != "")
                $entry["mail"] = $mail;
            if ($description && verifDescription($description))
                $entry["description"] = utf8_encode(stripslashes($description));

            if ($naissance != '' && verifDateNaissance($naissance)) {
                if (isset($user["sexe"])) {
                    $entry['physicaldeliveryofficename'] = $naissance . "," . $user['sexe'];
                }
            }

            if (implode(",", $newids) != $id) {
                $entry["employeenumber"] = implode(",", $newids);
            }
        }
        // Modification des entrees
        $res = modify_ad($config, $user['cn'], "user", $entry);
        if ($res) {
            echo "<strong>" . gettext("Les entr&#233;es ont &#233;t&#233; modifi&#233;es avec succ&#232;s.") . "</strong><br />\n";
        } else {
            echo "<strong>Echec de la modification</strong><br />\n";
        }

        // Fin modification des entrees
        // Changement du mot de passe
        if ($userpwd && verifPwd($userpwd)[0]) {
            usersetpassword($config, $cn, $userpwd);
        }

        echo "<p><a href='" . $_SERVER['PHP_SELF'] . "?cn=" . $cn . "'>Retour vers la modification des informations $cn</a></p>\n";
        echo "<p><a href='people.php?cn=" . $cn . "'>Retour vers la fiche de $cn</a></p>\n";
    }
} else {
    echo "<div class=error_msg>" . gettext("Cette fonctionnalit&#233; n&#233;cessite des droits d'administration SambaEdu !") . "</div>";
}

include ("pdp.inc.php");
?>