<?php
//
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("lang.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
echo header_authorize($config);
include "ihm.inc.php";
require "shortcuts.inc.php";

if (have_right($config, "se3_is_admin")) {
    $action = $_POST['action'] ?? "";
    echo "<h1>Gestion des applications Windows pour les clients Linux</h1>";
    echo "<FORM method=\"post\" action=\"wine.php\" enctype=\"multipart/form-data\">\n";

    echo " Cette page permet de gérer le support des applications Windows sur les postes Linux grâce à Wine.<p>
<p>Pour l'activer vous devez :</p>
<ul><li>Ajouter l'application Wpkg Wine aux parcs de clients linux concernés.</li>
<li>Sur un de ces clients Linux, vous connecter avec le compte <b>se4install</b> et installer les applications windows souhaitées avec Wine.
Il peut être utile d'installer quelques composants Windows avec <pre>winetricks</pre>
Par exemple :<pre>winetricks -q corefonts</pre></li>
<li>Il est également possible d'exéctuer directement des applications portables situées sur un partage réseau.</li>
<li>Une fois les applications installées, verifiez que le raccourci sur le bureau de l'application est bien fonctionnel. Il sera récupéré par la suite.</li>
<li>Se déconnecter de la session se4install, et génerer l'image partagée des applications avec le bouton ci-dessous.<br>
<input type=\"submit\" name=\"action\" value=\"Générer l'image\"></li>
<li>Générer les raccourcis pour pouvoir ensuite les affecter aux aux utilisateurs depuis cette page.<br>
<input type=\"submit\" name=\"action\" value=\"Générer les raccourcis\"></li></ul>
<p>Si vous souhaitez rajouter de nouvelles applications, il suffit de le faire depuis le compte se4install, puis de régénerer l'image. Si vous voulez tester une application, vous pouvez copier le dossier .wine en .wine.old, afin de pouvoir le restaurer en cas de problème.</p>
</FORM>";
    switch ($action) {
        case "Générer l'image":
            batch_command("/usr/share/sambaedu/scripts/make_wine_image.sh");
            batch_write("normal");
            break;
        case "Générer les raccourcis":
            $shortcuts = json_decode(file_get_contents("/etc/sambaedu/applications/shortcuts/shortcuts.json"), true) ?? [];
            $shortcuts = array_merge($shortcuts, get_wine_shortcuts($config));
            file_put_contents("/etc/sambaedu/applications/shortcuts/shortcuts.json", json_encode($shortcuts, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
            break;
    }
} else {
    print(gettext("Vous n'avez pas les droits n&#233;cessaires pour ouvrir cette page..."));
}
// Footer
include ("pdp.inc.php");
?>