<?php

function set_debug($config)
{
    $debug = $config['debug'] ?? 0;
    $sambaedu = get_fpm_conf("/fpm/pool.d/sambaedu.conf");
    $xdebug = get_fpm_conf("/mods-available/xdebug.ini");
    $xdebug['zend_extension'] = "xdebug.so";
    switch ($debug) {
        case 1:
            $xdebug['xdebug.mode'] = "trace";
            $xdebug['xdebug.show_error_trace'] = 1;
            $xdebug['xdebug.collect_params'] = 3;
            $sambaedu['sambaedu']['php_flag']['display_errors'] = "on";
            set_param($config, "debug", "1");
            echo "Mode debug activé dans 1 min !<br>";
            break;
        case 2:
            $xdebug['xdebug.mode'] = "profile";
            $xdebug['xdebug.show_error_trace'] = 0;
            $xdebug['xdebug.collect_params'] = 0;
            // $xdebug['xdebug.log'] = "/tmp";
            $xdebug['xdebug.profiler_append'] = 0;
            $xdebug['xdebug.profiler_output_name'] = "cachegrind.out%R";
            set_param($config, "debug", "2");
            echo "Mode profilage activé dans 1 min !<br>";
            break;
        default:
            $xdebug['xdebug.mode'] = "off";
            $xdebug['xdebug.show_error_trace'] = 0;
            $xdebug['xdebug.collect_params'] = 0;
            $sambaedu['sambaedu']['php_flag']['display_errors'] = "off";
            set_param($config, "debug", "0");
            echo "Mode debug désactivé dans 1 min !<br>";
    }
    $ret = set_fpm_conf($xdebug, "/mods-available/xdebug.ini");
    $ret &= set_fpm_conf($sambaedu, "/fpm/pool.d/sambaedu.conf");
    if ($ret) {
        batch_command("systemctl reload php" . PHP_MAJOR_VERSION . "." . PHP_MINOR_VERSION . "-fpm.service");
        batch_write("fast");
    }
}

?>